package soduko;
import java.io.*;

public class SudokuMiniTest {
	static short[] generate(String l) {
		char[] cs = l.toCharArray();
		short[] s = new short[81];
		for (int i = 0; i < cs.length; i++) {
			char c = cs[i];
			if (c == '.') s[i] = 0x1ff;
			else {
				s[i] = (short) (1 << (c - '0' - 1));
			}
		}
		return s;
	}
	static void print(short[] sudoku) {
		for (int row = 0; row < 9; row++) {
			for (int col = 0; col < 9; col++) {
				int v = sudoku[9*row + col];
				if (Util.bitCount(v) == 1) {
					int c = 1;
					while ((v & 1) == 0) {
						v >>= 1;
						c++;
					}
					System.out.print(c);
				} else System.out.print('0');
				
				if (col < 8 & col % 3 == 2) System.out.print(' ');
			}
			System.out.print("   ");
			
			for (int col = 0; col < 9; col++) {
				int v = sudoku[9*row + col];
				System.out.print("[");
				for (int i = 0, b = 1; i < 9; i++, b <<= 1) {
					System.out.print((v & b) != 0? Integer.toString(i+1) : " ");
				}
				System.out.print("]");
				if (col < 8 & col % 3 == 2) System.out.print(" | ");
			}
			System.out.println();
			if (row < 8 & row % 3 == 2) {
				System.out.println();
			}
		}
	}
	public static void main(String[] args) throws IOException {
		if (args.length > 0) {
			for (int i = 0; i < args.length; i++) {
				short[] s = generate(args[0]);
				SudokuSolverMini.solve(s);
				print(s);
			}
		} else {
			BufferedReader in = null;
			try {
				String l;
				in = new BufferedReader(new InputStreamReader(System.in));
				while ((l = in.readLine()) != null) {
					short[] s = generate(l);
					SudokuSolverMini.solve(s);
					print(s);
				}
			} finally {
				if (in != null) in.close();
			}
		}
	}
}
